Index: admin/permissions.php
===================================================================
--- admin/permissions.php	(revision 536)
+++ admin/permissions.php	(revision 536)
@@ -0,0 +1,160 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2011 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+require dirname(__FILE__).'/../inc/admin/prepend.php';
+
+dcPage::checkSuper();
+
+$changes = false;
+$blogs = array();
+$users = array();
+
+# Check users
+if (!empty($_REQUEST['user_id']) && is_array($_REQUEST['user_id']))
+{
+	foreach ($_REQUEST['user_id'] as $u)
+	{
+		if ($core->userExists($u)) {
+			$users[] = $u;
+		}
+	}
+}
+
+# Check blogs
+if (!empty($_REQUEST['blog_id']) && is_array($_REQUEST['blog_id']))
+{
+	foreach ($_REQUEST['blog_id'] as $b)
+	{
+		if ($core->blogExists($b)) {
+			$blogs[] = $b;
+		}
+	}
+}
+
+# Update permissions
+if (!empty($_POST['upd_perm']) && !empty($users) && !empty($blogs))
+{
+	$redir = 'permissions.php?upd=1';
+	
+	try
+	{
+		if (empty($_POST['your_pwd']) || !$core->auth->checkPassword(crypt::hmac(DC_MASTER_KEY,$_POST['your_pwd']))) {
+			throw new Exception(__('Password verification failed'));
+		}
+		
+		foreach ($users as $u)
+		{
+			foreach ($blogs as $b)
+			{
+				$set_perms = array();
+				
+				if (!empty($_POST['perm'][$b]))
+				{
+					foreach ($_POST['perm'][$b] as $perm_id => $v)
+					{
+						if ($v) {
+							$set_perms[$perm_id] = true;
+						}
+					}
+				}
+				
+				$core->setUserBlogPermissions($u, $b, $set_perms, true);
+			}
+			
+			$redir .= '&user_id[]='.$u;
+		}
+		
+		foreach ($blogs as $b) {
+			$redir .= '&blog_id[]='.$b;
+		}
+		http::redirect($redir);
+	}
+	catch (Exception $e)
+	{
+		$core->error->add($e->getMessage());
+	}
+}
+
+
+
+if (empty($blogs) || empty($users)) {
+	$core->error->add(__('No blog or user given.'));
+}
+
+
+/* DISPLAY
+-------------------------------------------------------- */
+dcPage::open(__('permissions'),
+	dcPage::jsLoad('js/_permissions.js')
+);
+
+echo '<h2><a href="users.php">'.__('Users').'</a> &rsaquo; <span class="page-title">'.__('Permissions').'</span></h2>';
+
+if (!empty($_GET['upd'])) {
+		echo '<p class="message">'.__('The permissions have been successfully updated.').'</p>';
+}
+
+if (!empty($blogs) && !empty($users))
+{
+	$perm_form = '';
+	
+	if (count($users) == 1) {
+			$user_perm = $core->getUserPermissions($users[0]);	
+	}
+	
+	foreach ($users as $u) {
+		$user_list[] = '<a href="user.php?id='.$u.'">'.$u.'</a>';
+	}
+	
+	echo '<p>'.sprintf(__('You are about to change permissions on the following blogs for users %s.'),
+	implode(', ',$user_list));
+	
+	echo '<form id="permissions-form" action="permissions.php" method="post">';
+	
+	foreach ($blogs as $b)
+	{
+		echo '<h3><a href="blog.php?id='.html::escapeHTML($b).'">'.html::escapeHTML($b).'</a>'.
+		form::hidden(array('blog_id[]'),$b).'</h3>';
+		
+		foreach ($core->auth->getPermissionsTypes() as $perm_id => $perm)
+		{
+			$checked = false;
+			
+			if (count($users) == 1) {
+				$checked = isset($user_perm[$b]['p'][$perm_id]) && $user_perm[$b]['p'][$perm_id];
+			}
+			
+			echo
+			'<p><label for="perm'.html::escapeHTML($b).html::escapeHTML($perm_id).'" class="classic">'.
+			form::checkbox(array('perm['.html::escapeHTML($b).']['.html::escapeHTML($perm_id).']','perm'.html::escapeHTML($b).html::escapeHTML($perm_id)),
+			1,$checked).' '.
+			__($perm).'</label></p>';
+		}
+	}
+	
+	echo
+	'<fieldset><legend>'.__('Validate permissions').'</legend>'.
+	'<p><label for="your_pwd">'.__('Your password:').
+	form::password('your_pwd',20,255).'</label></p>'.
+	'</fieldset>'.
+	'<p><input type="submit" accesskey="s" value="'.__('Save').'" />'.
+	$core->formNonce();
+	
+	foreach ($users as $u) {
+		echo form::hidden(array('user_id[]'),$u);
+	}
+	
+	echo	form::hidden('upd_perm',1).'</p></form>';
+}
+
+dcPage::close();
+?>
Index: admin/permissions_blog.php
===================================================================
--- admin/permissions_blog.php	(revision 782)
+++ admin/permissions_blog.php	(revision 782)
@@ -0,0 +1,116 @@
+<?php
+# -- BEGIN LICENSE BLOCK ---------------------------------------
+#
+# This file is part of Dotclear 2.
+#
+# Copyright (c) 2003-2010 Olivier Meunier & Association Dotclear
+# Licensed under the GPL version 2.0 license.
+# See LICENSE file or
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+#
+# -- END LICENSE BLOCK -----------------------------------------
+
+require dirname(__FILE__).'/../inc/admin/prepend.php';
+
+dcPage::checkSuper();
+
+$q = !empty($_GET['q']) ? $_GET['q'] : '';
+
+# Check users
+if (!empty($_REQUEST['user_id']) && is_array($_REQUEST['user_id']))
+{
+	foreach ($_REQUEST['user_id'] as $u)
+	{
+		if ($core->userExists($u)) {
+			$users[] = $u;
+		}
+	}
+}
+
+if (empty($users))
+{
+	$core->error->add(__('No blog or user given.'));
+}
+else
+{
+	$blogs_list = new adminBlogPermissionsList($core);
+	
+	$params = new ArrayObject();
+	
+	# - Limit, sortby and order filter
+	$params = $blogs_list->applyFilters($params);
+	
+	$show_filters = false;
+	
+	# - Search filter
+	if ($q) {
+		$params['q'] = $q;
+		$show_filters = true;
+	}
+	
+	try {
+		$rs = $core->getBlogs($params);
+		$counter = $core->getBlogs($params,1);
+		$blogs_list->setItems($rs,$counter->f(0));
+	} catch (Exception $e) {
+		$core->error->add($e->getMessage());
+	}
+}
+
+/* DISPLAY
+-------------------------------------------------------- */
+$starting_script = dcPage::jsLoad('js/_permissions_blog.js');
+if (!$show_filters) {
+	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
+}
+dcPage::open(__('choose a blog'),$starting_script);
+
+echo '<h2><a href="users.php">'.__('Users').'</a> &rsaquo; '.__('Choose a blog').'</h2>';
+
+if (!$core->error->flag())
+{
+	$hidden_fields = '';
+	foreach ($users as $u) {
+		$hidden_fields .= form::hidden(array('user_id[]'),$u);
+	}
+	
+	if (!$show_filters) {
+		echo '<p><a id="filter-control" class="form-control" href="#">'.__('Filters').'</a></p>';
+	}
+	
+	echo
+	'<form action="permissions_blog.php" method="get" id="filters-form">'.
+	'<fieldset class="two-cols"><legend>'.__('Filters').'</legend>'.
+	
+	'<p><label for="q">'.__('Search:').' '.
+	form::field('q',20,255,html::escapeHTML($q)).
+	'</label></p>'.
+	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
+	__('Entries per page').'</label> '.
+	'<input type="submit" value="'.__('Apply filters').'" />'.
+	$hidden_fields.'</p>'.
+	
+	'<br class="clear" />'. //Opera sucks
+	'</fieldset>'.
+	'</form>';
+	
+	echo
+	'<p>'.
+	sprintf(__('Choose one or more blogs to which you want to give permissions to users %s.'),
+	'<strong>'.implode(', ',$users).'</strong>').'</p>';
+	
+	# Show blogs
+	$blogs_list->display('<form action="permissions.php" method="post" id="form-blogs">'.
+		'%s'.
+		'<p class="checkboxes-helpers"></p>'.
+		
+		'<p><input type="submit" value="'.__('set permissions').'" />'.
+		$hidden_fields.
+		$core->formNonce().'</p>'.
+		'</form>'
+	);
+}
+
+dcPage::close();
+
+?>
Index: admin/plugins.php
===================================================================
--- admin/plugins.php	(revision 961)
+++ admin/plugins.php	(revision 782)
@@ -85,12 +85,5 @@
 			}
 			
-			# --BEHAVIOR-- pluginBeforeDeactivate
-			$core->callBehavior('pluginsBeforeDeactivate', $plugin);
-				
 			$core->plugins->deactivateModule($plugin_id);
-
-			# --BEHAVIOR-- pluginAfterDeactivate
-			$core->callBehavior('pluginsAfterDeactivate', $plugin);
-				
 			http::redirect('plugins.php');
 		}
@@ -109,13 +102,5 @@
 				throw new Exception(__('No such plugin.'));
 			}
-
-			# --BEHAVIOR-- pluginBeforeActivate
-			$core->callBehavior('pluginsBeforeActivate', $plugin_id);
-			
 			$core->plugins->activateModule($plugin_id);
-
-			# --BEHAVIOR-- pluginAfterActivate
-			$core->callBehavior('pluginsAfterActivate', $plugin_id);
-			
 			http::redirect('plugins.php');
 		}
@@ -165,13 +150,6 @@
 				unset($client);
 			}
-
-			# --BEHAVIOR-- pluginBeforeAdd
-			$core->callBehavior('pluginsBeforeAdd', $plugin);
-						
+			
 			$ret_code = $core->plugins->installPackage($dest,$core->plugins);
-
-			# --BEHAVIOR-- pluginAfterAdd
-			$core->callBehavior('pluginsAfterAdd', $plugin);
-			
 			http::redirect('plugins.php?added='.$ret_code);
 		}
@@ -198,8 +176,11 @@
 
 if (!empty($_GET['removed'])) {
-	dcPage::message(__('Plugin has been successfully deleted.'));
+	echo
+	'<p class="message">'.__('Plugin has been successfully deleted.').'</p>';
 }
 if (!empty($_GET['added'])) {
-	dcPage::message(($_GET['added'] == 2 ? __('Plugin has been successfully upgraded') : __('Plugin has been successfully installed.')));
+	echo	'<p class="message">'.
+	($_GET['added'] == 2 ? __('Plugin has been successfully upgraded') : __('Plugin has been successfully installed.')).
+	'</p>';
 }
 
@@ -246,28 +227,25 @@
 	echo
 	'<h3>'.__('Activated plugins').'</h3>'.
-	'<table class="clear plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Version').'</th>'.
-	'<th class="nowrap">'.__('Details').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
+	'<table class="clear plugins">'.
+	'<caption>'.__('Activated plugin list').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col">'.__('Plugin').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Version').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Details').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
-	$distrib_plugins = array('aboutConfig','akismet','antispam','attachments','blogroll','blowupConfig','fairTrackbacks',
-		'importExport','maintenance','pages','pings','simpleMenu','tags','themeEditor','userPref','widgets');
-	$distrib_img = '<img src="images/dotclear_pw.png"'.
-		' alt="'.__('Plugin from official distribution').'" title="'.__('Plugin from official distribution').'" />';
-
 	foreach ($p_available as $k => $v)
 	{
 		$is_deletable = $is_writable && preg_match('!^'.$p_path_pat.'!',$v['root']);
 		$is_deactivable = $v['root_writable'];
-		$is_distrib = in_array($k, $distrib_plugins);
 		
 		echo
 		'<tr class="line wide">'.
-		'<td class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
+		'<th scope="row" class="minimal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
 		'<td class="minimal">'.html::escapeHTML($v['version']).'</td>'.
-		'<td class="maximal'.($is_distrib ? ' distrib' : '').'"><strong>'.html::escapeHTML(__($v['name'])).'</strong> '.
-		'<br />'.html::escapeHTML(__($v['desc'])).($is_distrib ? ' '.$distrib_img : '').'</td>'.
+		'<td class="maximal"><strong>'.html::escapeHTML($v['name']).'</strong> '.
+		'<br />'.html::escapeHTML($v['desc']).'</td>'.
 		'<td class="nowrap action">';
 		
@@ -290,4 +268,5 @@
 	}
 	echo
+	'</tbody>'.
 	'</table>';
 }
@@ -299,8 +278,11 @@
 	echo
 	'<h3>'.__('Deactivated plugins').'</h3>'.
-	'<table class="clear plugins"><tr>'.
-	'<th>'.__('Plugin').'</th>'.
-	'<th class="nowrap">'.__('Action').'</th>'.
-	'</tr>';
+	'<table class="clear plugins">'.
+	'<caption>'.__('Deactivated plugin list').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col">'.__('Plugin').'</th>'.
+	'<th scope="col" class="nowrap">'.__('Action').'</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	foreach ($p_disabled as $k => $v)
@@ -311,5 +293,5 @@
 		echo
 		'<tr class="line wide">'.
-		'<td class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></td>'.
+		'<th scope="row" class="maximal nowrap"><strong>'.html::escapeHTML($k).'</strong></th>'.
 		'<td class="nowrap action">';
 		
@@ -333,4 +315,5 @@
 	}
 	echo
+	'</tbody>'.
 	'</table>';
 }
Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 557)
+++ admin/popup_posts.php	(revision 782)
@@ -17,11 +17,11 @@
 $q = !empty($_GET['q']) ? $_GET['q'] : null;
 
-$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
-$nb_per_page =  10;
+$post_list = new adminPostMiniList($core);
 
 $params = array();
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
 $params['no_content'] = true;
-$params['order'] = 'post_dt DESC';
+
+# - Limit, sortby and order filter
+$params = $post_list->applyFilters($params);
 
 if ($q) {
@@ -43,5 +43,5 @@
 	$posts = $core->blog->getPosts($params);
 	$counter = $core->blog->getPosts($params,true);
-	$post_list = new adminPostMiniList($core,$posts,$counter->f(0));
+	$post_list->setItems($posts,$counter->f(0));
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
@@ -49,5 +49,5 @@
 
 echo '<div id="form-entries">'; # I know it's not a form but we just need the ID
-$post_list->display($page,$nb_per_page);
+$post_list->display();
 echo '</div>';
 
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 957)
+++ admin/post.php	(revision 782)
@@ -66,5 +66,4 @@
 	$status_combo[$v] = (string) $k;
 }
-$img_status_pattern = '<img class="img_select_option" alt="%1$s" title="%1$s" src="images/%2$s" />';
 
 # Formaters combo
@@ -88,6 +87,4 @@
 unset($rs);
 
-# Validation flag
-$bad_dt = false;
 
 # Get entry informations
@@ -169,17 +166,6 @@
 		$post_dt = '';
 	} else {
-		try
-		{
-			$post_dt = strtotime($_POST['post_dt']);
-			if ($post_dt == false || $post_dt == -1) {
-				$bad_dt = true;
-				throw new Exception(__('Invalid publication date'));
-			}
-			$post_dt = date('Y-m-d H:i',$post_dt);
-		}
-		catch (Exception $e)
-		{
-			$core->error->add($e->getMessage());
-		}
+		$post_dt = strtotime($_POST['post_dt']);
+		$post_dt = date('Y-m-d H:i',$post_dt);
 	}
 	
@@ -203,5 +189,5 @@
 
 # Create or update post
-if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post && !$bad_dt)
+if (!empty($_POST) && !empty($_POST['save']) && $can_edit_post)
 {
 	$cur = $core->con->openCursor($core->prefix.'post');
@@ -307,19 +293,19 @@
 
 if (!empty($_GET['upd'])) {
-	dcPage::message(__('Entry has been successfully updated.'));
+		echo '<p class="message">'.__('Entry has been successfully updated.').'</p>';
 }
 elseif (!empty($_GET['crea'])) {
-	dcPage::message(__('Entry has been successfully created.'));
+		echo '<p class="message">'.__('Entry has been successfully created.').'</p>';
 }
 elseif (!empty($_GET['attached'])) {
-	dcPage::message(__('File has been successfully attached.'));
+	echo '<p class="message">'.__('File has been successfully attached.').'</p>';
 }
 elseif (!empty($_GET['rmattach'])) {
-	dcPage::message(__('Attachment has been successfully removed.'));
+	echo '<p class="message">'.__('Attachment has been successfully removed.').'</p>';
 }
 
 if (!empty($_GET['creaco'])) {
-	dcPage::message(__('Comment has been successfully created.'));
-}
+		echo '<p class="message">'.__('Comment has been successfully created.').'</p>';
+	}
 
 # XHTML conversion
@@ -328,29 +314,15 @@
 	$post_excerpt = $post_excerpt_xhtml;
 	$post_content = $post_content_xhtml;
+	$post_title = $post_title_xhtml;
 	$post_format = 'xhtml';
 	
-	dcPage::message(__('Don\'t forget to validate your XHTML conversion by saving your post.'));
+	echo '<p class="message">'.__('Don\'t forget to validate your XHTML conversion by saving your post.').'</p>';
 }
 
 echo '<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; '.'<a href="posts.php">'.__('Entries').'</a> &rsaquo; <span class="page-title">'.$page_title;
-if ($post_id) {
-	switch ($post_status) {
-		case 1:
-			$img_status = sprintf($img_status_pattern,__('published'),'check-on.png');
-			break;
-		case 0:
-			$img_status = sprintf($img_status_pattern,__('unpublished'),'check-off.png');
-			break;
-		case -1:
-			$img_status = sprintf($img_status_pattern,__('scheduled'),'scheduled.png');
-			break;
-		case -2:
-			$img_status = sprintf($img_status_pattern,__('pending'),'check-wrn.png');
-			break;
-		default:
-			$img_status = '';
-	}
-	echo ' &ldquo;'.$post_title.'&rdquo;'.' '.$img_status;
-}
+
+	if ($post_id) {
+		echo ' &ldquo;'.$post_title.'&rdquo;';
+	}
 echo	'</span></h2>';
 
@@ -440,5 +412,5 @@
 	
 	'<p><label for="post_dt">'.__('Published on:').
-	form::field('post_dt',16,16,$post_dt,($bad_dt ? 'invalid' : '')).
+	form::field('post_dt',16,16,$post_dt).
 	'</label></p>'.
 	
@@ -451,18 +423,6 @@
 	'<p><label for="post_open_comment" class="classic">'.form::checkbox('post_open_comment',1,$post_open_comment).' '.
 	__('Accept comments').'</label></p>'.
-	($core->blog->settings->system->allow_comments ? 
-		(isContributionAllowed($post_id,strtotime($post_dt),true) ? 
-			'' :
-			'<p class="form-note warn">'.__('Warning: Comments are not more accepted for this entry.').'</p>') : 
-		'<p class="form-note warn">'.__('Warning: Comments are not accepted on this blog.').'</p>').
-
 	'<p><label for="post_open_tb" class="classic">'.form::checkbox('post_open_tb',1,$post_open_tb).' '.
 	__('Accept trackbacks').'</label></p>'.
-	($core->blog->settings->system->allow_trackbacks ? 
-		(isContributionAllowed($post_id,strtotime($post_dt),false) ? 
-			'' :
-			'<p class="form-note warn">'.__('Warning: Trackbacks are not more accepted for this entry.').'</p>') : 
-		'<p class="form-note warn">'.__('Warning: Trackbacks are not accepted on this blog.').'</p>').
-
 	'<p><label for="post_selected" class="classic">'.form::checkbox('post_selected',1,$post_selected).' '.
 	__('Selected entry').'</label></p>'.
@@ -608,25 +568,4 @@
 }
 
-# Controls comments or trakbacks capabilities
-function isContributionAllowed($id,$dt,$com=true)
-{
-	global $core;
-
-	if (!$id) {
-		return true;
-	}
-	if ($com) {
-		if (($core->blog->settings->system->comments_ttl == 0) || 
-			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
-			return true;
-		}
-	} else {
-		if (($core->blog->settings->system->trackbacks_ttl == 0) || 
-			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
-			return true;
-		}
-	}
-	return false;
-}
 
 # Show comments or trackbacks
@@ -634,11 +573,14 @@
 {
 	echo
-	'<table class="comments-list"><tr>'.
-	'<th colspan="2">'.__('Author').'</th>'.
-	'<th>'.__('Date').'</th>'.
-	'<th class="nowrap">'.__('IP address').'</th>'.
-	'<th>'.__('Status').'</th>'.
-	'<th>&nbsp;</th>'.
-	'</tr>';
+	'<table class="comments-list">'.
+	'<caption>'.__('Post comments and trackbacks').'</caption>'.
+	'<thead><tr>'.
+	'<th scope="col" colspan="2">'.__('Author').'</th>'.
+	'<th scope="col">'.__('Date').'</th>'.
+	'<th scope="col" class="nowrap">'.__('IP address').'</th>'.
+	'<th scope="col">'.__('Status').'</th>'.
+	'<th scope="col">&nbsp;</th>'.
+	'</tr></thead>'.
+	'<tbody>';
 	
 	while($rs->fetch())
@@ -668,5 +610,5 @@
 		'<td class="nowrap">'.
 		($has_action ? form::checkbox(array('comments[]'),$rs->comment_id,'','','',0,'title="'.($tb ? __('select this trackback') : __('select this comment')).'"') : '').'</td>'.
-		'<td class="maximal">'.html::escapeHTML($rs->comment_author).'</td>'.
+		'<th scope="row" class="maximal">'.html::escapeHTML($rs->comment_author).'</th>'.
 		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$rs->comment_dt).'</td>'.
 		'<td class="nowrap"><a href="comments.php?ip='.$rs->comment_ip.'">'.$rs->comment_ip.'</a></td>'.
@@ -678,5 +620,7 @@
 	}
 	
-	echo '</table>';
+	echo
+	'</tbody>'.
+	'</table>';
 }
 
Index: admin/posts.php
===================================================================
--- admin/posts.php	(revision 796)
+++ admin/posts.php	(revision 782)
@@ -48,5 +48,4 @@
 	# Filter form we'll put in html_block
 	$users_combo = $categories_combo = array();
-	$users_combo['-'] = $categories_combo['-'] = '';
 	while ($users->fetch())
 	{
@@ -63,5 +62,5 @@
 	$categories_combo[__('None')] = 'NULL';
 	while ($categories->fetch()) {
-		$categories_combo[str_repeat('&nbsp;&nbsp;',$categories->level-1).($categories->level-1 == 0 ? '' : '&bull; ').
+		$categories_combo[str_repeat('&nbsp;&nbsp;',$categories->level-1).'&bull; '.
 			html::escapeHTML($categories->cat_title).
 			' ('.$categories->nb_post.')'] = $categories->cat_id;
@@ -69,5 +68,4 @@
 	
 	$status_combo = array(
-	'-' => ''
 	);
 	foreach ($core->blog->getAllPostStatus() as $k => $v) {
@@ -76,33 +74,16 @@
 	
 	$selected_combo = array(
-	'-' => '',
-	__('selected') => '1',
-	__('not selected') => '0'
+	__('is selected') => '1',
+	__('is not selected') => '0'
 	);
 	
 	# Months array
-	$dt_m_combo['-'] = '';
 	while ($dates->fetch()) {
 		$dt_m_combo[dt::str('%B %Y',$dates->ts())] = $dates->year().$dates->month();
 	}
 	
-	$lang_combo['-'] = '';
 	while ($langs->fetch()) {
 		$lang_combo[$langs->post_lang] = $langs->post_lang;
 	}
-	
-	$sortby_combo = array(
-	__('Date') => 'post_dt',
-	__('Title') => 'post_title',
-	__('Category') => 'cat_title',
-	__('Author') => 'user_id',
-	__('Status') => 'post_status',
-	__('Selected') => 'post_selected'
-	);
-	
-	$order_combo = array(
-	__('Descending') => 'desc',
-	__('Ascending') => 'asc'
-	);
 }
 
@@ -138,108 +119,63 @@
 /* Get posts
 -------------------------------------------------------- */
-$user_id = !empty($_GET['user_id']) ?	$_GET['user_id'] : '';
-$cat_id = !empty($_GET['cat_id']) ?	$_GET['cat_id'] : '';
-$status = isset($_GET['status']) ?	$_GET['status'] : '';
-$selected = isset($_GET['selected']) ?	$_GET['selected'] : '';
-$month = !empty($_GET['month']) ?		$_GET['month'] : '';
-$lang = !empty($_GET['lang']) ?		$_GET['lang'] : '';
-$sortby = !empty($_GET['sortby']) ?	$_GET['sortby'] : 'post_dt';
-$order = !empty($_GET['order']) ?		$_GET['order'] : 'desc';
-
-$show_filters = false;
-
-$page = !empty($_GET['page']) ? (integer) $_GET['page'] : 1;
-$nb_per_page =  30;
-
-if (!empty($_GET['nb']) && (integer) $_GET['nb'] > 0) {
-	if ($nb_per_page != $_GET['nb']) {
-		$show_filters = true;
-	}
-	$nb_per_page = (integer) $_GET['nb'];
-}
-
-$params['limit'] = array((($page-1)*$nb_per_page),$nb_per_page);
+$post_list = new adminPostList($core);
+
+$params = new ArrayObject();
 $params['no_content'] = true;
 
-# - User filter
-if ($user_id !== '' && in_array($user_id,$users_combo)) {
-	$params['user_id'] = $user_id;
-	$show_filters = true;
-} else {
-	$user_id='';
-}
-
-# - Categories filter
-if ($cat_id !== '' && in_array($cat_id,$categories_combo)) {
-	$params['cat_id'] = $cat_id;
-	$show_filters = true;
-} else {
-	$cat_id='';
-}
-
-# - Status filter
-if ($status !== '' && in_array($status,$status_combo)) {
-	$params['post_status'] = $status;
-	$show_filters = true;
-} else {
-	$status='';
-}
-
-# - Selected filter
-if ($selected !== '' && in_array($selected,$selected_combo)) {
-	$params['post_selected'] = $selected;
-	$show_filters = true;
-} else {
-	$selected='';
-}
-
-# - Month filter
-if ($month !== '' && in_array($month,$dt_m_combo)) {
-	$params['post_month'] = substr($month,4,2);
-	$params['post_year'] = substr($month,0,4);
-	$show_filters = true;
-} else {
-	$month='';
-}
-
-# - Lang filter
-if ($lang !== '' && in_array($lang,$lang_combo)) {
-	$params['post_lang'] = $lang;
-	$show_filters = true;
-} else {
-	$lang='';
-}
-
-# - Sortby and order filter
-if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
-	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
-	} else {
-		$order='desc';
-	}
-	
-	if ($sortby != 'post_dt' || $order != 'desc') {
-		$show_filters = true;
-	}
-} else {
-	$sortby='post_dt';
-	$order='desc';
-}
+$filterSet = new dcFilterSet('posts','posts.php');
+class monthComboFilter extends comboFilter {
+	public function applyFilter($params) {
+		$month=$this->values[0];
+		$params['post_month'] = substr($month,4,2);
+		$params['post_year'] = substr($month,0,4);
+	}
+}
+$filterSet
+	->addFilter(new comboFilter(
+		'users',__('Author'), __('Author'), 'user_id', $users_combo))
+	->addFilter(new categoryFilter(
+		'category',__('Category'), __('Category'), 'cat_id', $categories_combo))
+	->addFilter(new comboFilter(
+		'post_status',__('Status'), __('Status'), 'post_status', $status_combo))
+	->addFilter(new booleanFilter(
+		'post_selected',__('Selected'), __('The post : '),'post_selected', $selected_combo))
+	->addFilter(new comboFilter(
+		'lang',__('Lang'), __('Lang'), 'post_lang', $lang_combo))
+	->addFilter(new monthComboFilter(
+		'month',__('Month'),__('Month'), 'post_month', $dt_m_combo,array('singleval' => 1)))
+	->addFilter(new textFilter(
+		'search',__('Contains'),__('The entry contains'), 'search',20,255));
+
+$core->callBehavior('adminPostsFilters',$filterSet);
+$filterSet->setExtra($post_list);
+
+$filterSet->setup($_GET,$_POST);
 
 # Get posts
 try {
+	$nfparams = $params->getArrayCopy();
+	$filtered = $filterSet->applyFilters($params);
+	$core->callBehavior('adminPostsParams',$params);
 	$posts = $core->blog->getPosts($params);
 	$counter = $core->blog->getPosts($params,true);
-	$post_list = new adminPostList($core,$posts,$counter->f(0));
-} catch (Exception $e) {
-	$core->error->add($e->getMessage());
-}
+	if ($filtered) {
+		$totalcounter = $core->blog->getPosts($nfparams,true);
+		$page_title = sprintf(__('Entries / %s filtered out of %s'),$counter->f(0),$totalcounter->f(0));
+	} else {
+		$page_title = __('Entries');
+		$filters_info = '';
+	}
+	$post_list->setItems($posts,$counter->f(0));
+} catch (Exception $e) {
+	$core->error->add($e->getMessage());
+}
+
 
 /* DISPLAY
 -------------------------------------------------------- */
 $starting_script = dcPage::jsLoad('js/_posts_list.js');
-if (!$show_filters) {
-	$starting_script .= dcPage::jsLoad('js/filter-controls.js');
-}
+
+$starting_script .= $filterSet->header();
 
 dcPage::open(__('Entries'),$starting_script);
@@ -250,49 +186,8 @@
 	'<h2>'.html::escapeHTML($core->blog->name).' &rsaquo; <span class="page-title">'.__('Entries').'</span></h2>'.
 	'<p class="top-add"><a class="button add" href="post.php">'.__('New entry').'</a></p>';
-	
-	if (!$show_filters) {
-		echo '<p><a id="filter-control" class="form-control" href="#">'.
-		__('Filters').'</a></p>';
-	}
-	
-	echo
-	'<form action="posts.php" method="get" id="filters-form">'.
-	'<fieldset><legend>'.__('Filters').'</legend>'.
-	'<div class="three-cols">'.
-	'<div class="col">'.
-	'<label for="user_id">'.__('Author:').
-	form::combo('user_id',$users_combo,$user_id).'</label> '.
-	'<label for="cat_id">'.__('Category:').
-	form::combo('cat_id',$categories_combo,$cat_id).'</label> '.
-	'<label for="status">'.__('Status:').
-	form::combo('status',$status_combo,$status).'</label> '.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<label for="selected">'.__('Selected:').
-	form::combo('selected',$selected_combo,$selected).'</label> '.
-	'<label for="month">'.__('Month:').
-	form::combo('month',$dt_m_combo,$month).'</label> '.
-	'<label for="lang">'.__('Lang:').
-	form::combo('lang',$lang_combo,$lang).'</label> '.
-	'</div>'.
-	
-	'<div class="col">'.
-	'<p><label for="sortby">'.__('Order by:').
-	form::combo('sortby',$sortby_combo,$sortby).'</label> '.
-	'<label for="order">'.__('Sort:').
-	form::combo('order',$order_combo,$order).'</label></p>'.
-	'<p><label for="nb" class="classic">'.	form::field('nb',3,3,$nb_per_page).' '.
-	__('Entries per page').'</label></p> '.
-	'<p><input type="submit" value="'.__('Apply filters').'" /></p>'.
-	'</div>'.
-	'</div>'.
-	'<br class="clear" />'. //Opera sucks
-	'</fieldset>'.
-	'</form>';
-	
+
+	$filterSet->display();
 	# Show posts
-	$post_list->display($page,$nb_per_page,
-	'<form action="posts_actions.php" method="post" id="form-entries">'.
+	$post_list->display('<form action="posts_actions.php" method="post" id="form-entries">'.
 	
 	'%s'.
@@ -304,19 +199,11 @@
 	form::combo('action',$combo_action).
 	'<input type="submit" value="'.__('ok').'" /></p>'.
-	form::hidden(array('user_id'),$user_id).
-	form::hidden(array('cat_id'),$cat_id).
-	form::hidden(array('status'),$status).
-	form::hidden(array('selected'),$selected).
-	form::hidden(array('month'),$month).
-	form::hidden(array('lang'),$lang).
-	form::hidden(array('sortby'),$sortby).
-	form::hidden(array('order'),$order).
-	form::hidden(array('page'),$page).
-	form::hidden(array('nb'),$nb_per_page).
+	str_replace('%','%%',$filterSet->getFormFieldsAsHidden()).
 	$core->formNonce().
 	'</div>'.
 	'</form>'
 	);
-}
+	}
+
 
 dcPage::helpBlock('core_posts');
Index: admin/posts_actions.php
===================================================================
--- admin/posts_actions.php	(revision 500)
+++ admin/posts_actions.php	(revision 782)
@@ -31,14 +31,5 @@
 	{
 		$redir =
-		'posts.php?user_id='.$_POST['user_id'].
-		'&cat_id='.$_POST['cat_id'].
-		'&status='.$_POST['status'].
-		'&selected='.$_POST['selected'].
-		'&month='.$_POST['month'].
-		'&lang='.$_POST['lang'].
-		'&sortby='.$_POST['sortby'].
-		'&order='.$_POST['order'].
-		'&page='.$_POST['page'].
-		'&nb='.$_POST['nb'];
+		'posts.php?'.urldecode($_POST['f_query']);
 	}
 	
